#include <stdio.h>
#include <dirent.h>
#include <GL/glut.h>

#include <mui/mui.h>

#include "vge.h"
#include "viz.h"

#define W 450
#define H 480

muiObject *b1, *b2, *b3, *b4, *b5, *b6;
muiObject *b21, *b22, *b23;
muiObject *t1, *t2, *t3, *t4;
muiObject *t21, *t22, *t23, *t24, *t25, *t26, *t27, *t28;
muiObject *l1, *l2, *vs;
muiObject *l21, *l22;
muiObject *trb1, *trb2, *trb3;
muiObject *trb21, *trb22, *trb23, *trb24;
muiObject *trb25, *trb26;

int mainWID, subRoll1WID, subRoll2WID, subRoll3WID, subAxisWID;
int LODWID=-1;
int mui1, mui2;
int lastX, lastY, lastBut, lastState;

GLfloat rot[3];
GLfloat rot1[3];
GLfloat rot2[3];
GLfloat rot3[3];

typedef struct{
    GLuint	list;
    GLuint	size[3];
} TList;

enum {NAV, ROTATE, SCALE};
int mode = NAV;

TTexture t;
TList	list[256];
char	*fName[256];
char	*dName;
char	filter[]="3dt";

int topList	= -1;
int maxList	= -1;
int selList	= -1;


void redisplayAll( void );
void clearTextPropr( void );
void createQuadList( void );
int  getSelIndexOf(char *);
void updateLOD (void);

#define BOX(sx, sy, sz)   \
  glPushMatrix();	\
  glDisable(GL_LIGHTING); \
  glColor3f(1.0, 0.0, 0.0); \
  glRotatef(-90.0, 1.0, 0.0, 0.0); \
  glRotatef(-90.0, 0.0, 0.0, 1.0); \
  glBegin(GL_LINE_LOOP);  \
    glVertex3f( sx/-2.0, sy/-2.0, sz/-2.0); \
    glVertex3f( sx/ 2.0, sy/-2.0, sz/-2.0); \
    glVertex3f( sx/ 2.0, sy/ 2.0, sz/-2.0); \
    glVertex3f( sx/-2.0, sy/ 2.0, sz/-2.0); \
  glEnd(); \
  glBegin(GL_LINE_LOOP);  \
    glVertex3f( sx/-2.0, sy/-2.0, sz/2.0); \
    glVertex3f( sx/ 2.0, sy/-2.0, sz/2.0); \
    glVertex3f( sx/ 2.0, sy/ 2.0, sz/2.0); \
    glVertex3f( sx/-2.0, sy/ 2.0, sz/2.0); \
  glEnd(); \
  glBegin(GL_LINE_LOOP);  \
    glVertex3f( sx/ 2.0, sy/-2.0, sz/-2.0); \
    glVertex3f( sx/ 2.0, sy/ 2.0, sz/-2.0); \
    glVertex3f( sx/ 2.0, sy/ 2.0, sz/ 2.0); \
    glVertex3f( sx/ 2.0, sy/-2.0, sz/ 2.0); \
  glEnd(); \
  glBegin(GL_LINE_LOOP);  \
    glVertex3f( sx/-2.0, sy/-2.0, sz/-2.0); \
    glVertex3f( sx/-2.0, sy/ 2.0, sz/-2.0); \
    glVertex3f( sx/-2.0, sy/ 2.0, sz/ 2.0); \
    glVertex3f( sx/-2.0, sy/-2.0, sz/ 2.0); \
  glEnd(); \
  glEnable(GL_LIGHTING);\
  glPopMatrix();
  
#define AXES(sx, sy, sz)  \
  glPushMatrix();	\
  glDisable(GL_LIGHTING); \
  glRotatef(-90.0, 1.0, 0.0, 0.0); \
  glRotatef(-90.0, 0.0, 0.0, 1.0); \
  glColor3f(1.0, 1.0, 0.0); \
  glBegin(GL_LINES);  \
    glVertex3f( sx/-2.0, sy/-2.0, sz/-2.0); \
    glVertex3f( sx/ 2.0, sy/-2.0, sz/-2.0); \
  glEnd(); \
  glColor3f(0.0, 1.0, 0.0); \
  glBegin(GL_LINES);  \
    glVertex3f( sx/-2.0, sy/-2.0, sz/-2.0); \
    glVertex3f( sx/-2.0, sy/ 2.0, sz/-2.0); \
  glEnd(); \
  glColor3f(0.0, 0.0, 1.0); \
  glBegin(GL_LINES);  \
    glVertex3f( sx/-2.0, sy/-2.0, sz/-2.0); \
    glVertex3f( sx/-2.0, sy/-2.0, sz/ 2.0); \
  glEnd(); \
  glEnable(GL_LIGHTING);\
  glPopMatrix();

#define MAX3(a, b, c) (a>b)?((a>c)?a:c):((b>c)?b:c)

/**********************************************************/
/******************* ****  LOD  ***** ********************/
/**********************************************************/
/**********************************************************/
void closeLODWin(void){

    glutSetWindow(LODWID);
    glutHideWindow ();
    glutSetWindow(mainWID);
}


void applyLODVal(void){
    if (trb25->active){
      printf("LOD is interpolated\n");
      t.isVRMLLOD = 0;
      printf("Dir: %s\n", t.path);
      printf("1. %s\n", t.fName[0]);
      printf("2. %s\n", t.fName[1]);
      printf("3. %s\n", t.fName[2]);
      printf("4. %s\n", t.fName[3]);
    }
    else{
      t.isVRMLLOD = 1;
      strcpy(t.path, dName);
      
      t.radius[0] = t.radius[1] = t.radius[2] = t.radius[3] = 0;
      
      sscanf(muiGetTBString(t25),"%d", &t.radius[0]);
      sscanf(muiGetTBString(t26),"%d", &t.radius[1]);
      sscanf(muiGetTBString(t27),"%d", &t.radius[2]);
      sscanf(muiGetTBString(t28),"%d", &t.radius[3]);
      
      strcpy(t.fName[0], muiGetTBString(t21));
      strcpy(t.fName[1], muiGetTBString(t22));
      strcpy(t.fName[2], muiGetTBString(t23));
      strcpy(t.fName[3], muiGetTBString(t24));

#if 0
	printf("Dir: %s\n", t.path);
      printf("1. %s radius: %d\n", t.fName[0], t.radius[0]);
      printf("2. %s radius: %d\n", t.fName[1], t.radius[1]);
      printf("3. %s radius: %d\n", t.fName[2], t.radius[2]);
      printf("4. %s radius: %d\n", t.fName[3], t.radius[3]);
#endif
    }
}


void CancelCB(muiObject *obj, enum muiReturnValue r){
    closeLODWin();
}


void OKCB(muiObject *obj, enum muiReturnValue r){
    applyLODVal();
    closeLODWin();
}


void ApplyCB(muiObject *obj, enum muiReturnValue r){
    applyLODVal();
}


void lod1CB(muiObject *obj, enum muiReturnValue r){

    if (obj->active){
      if (trb26->active){
        if (fName[selList]){
          muiSetTBString(t21, fName[selList]);
	  muiSetTBString(t25, "-1");
        }
      }
      else
        muiClearRadio(obj);
    }
    else{
      if (trb22->active) {
        muiSetActive(obj, 1);
	muiSetTBString(t21, muiGetTBString(t22));
	muiSetTBString(t25, muiGetTBString(t26));
	if (trb23->active){
	  muiSetTBString(t22, muiGetTBString(t23));
	  muiSetTBString(t26, muiGetTBString(t27));
	  if (trb24->active){
	    muiSetTBString(t23, muiGetTBString(t24));
	    muiSetTBString(t27, muiGetTBString(t28));
	    muiSetActive(trb24, 0);
	    muiClearTBString(t24);
	    muiClearTBString(t28);
	  }
	  else{
	    muiClearTBString(t23);
	    muiClearTBString(t27);
	    muiSetActive(trb23, 0);
	  }
	}
	else{
	  muiClearTBString(t22);
	  muiClearTBString(t26);
	  muiSetActive(trb22, 0);
	}
      }
      else{
        muiClearTBString(t21);
	muiClearTBString(t25);
      }
    }
}


void lod2CB(muiObject *obj, enum muiReturnValue r){

    if (obj->active){
      if (trb26->active && trb21->active){
        if (fName[selList]) muiSetTBString(t22, fName[selList]);
	if (strcmp("-1", muiGetTBString(t25))){
	  muiSetTBString(t26, "-1");
	}
	else{
	  muiSetTBString(t25, "10");
	  muiSetTBString(t26, "-1");
	}
      }
      else
        muiClearRadio(obj);
    }
    else{
	if (trb23->active){
          muiSetActive(obj, 1);
	  muiSetTBString(t22, muiGetTBString(t23));
	  muiSetTBString(t26, muiGetTBString(t27));
	  if (trb24->active){
	    muiSetTBString(t23, muiGetTBString(t24));
	    muiSetTBString(t27, muiGetTBString(t28));
	    muiSetActive(trb24, 0);
	    muiClearTBString(t24);
	    muiClearTBString(t28);
	  }
	  else{
	    muiClearTBString(t23);
	    muiClearTBString(t27);
	    muiSetActive(trb23, 0);
	  }
	}
	else{
	  muiClearTBString(t22);
	  muiClearTBString(t26);
	  muiSetActive(trb22, 0);
	}
    }
}


void lod3CB(muiObject *obj, enum muiReturnValue r){

  if (obj->active){
    if (trb26->active && trb21->active && trb22->active){
      if (fName[selList]) muiSetTBString(t23, fName[selList]);
	if (strcmp("-1", muiGetTBString(t26))){
	  muiSetTBString(t27, "-1");
	}
	else{
          int num;
	  char str[25];
	  sscanf(muiGetTBString(t25),"%d",&num);
	  sprintf(str,"%d", (num+10));
	  muiSetTBString(t26, str);
	  muiSetTBString(t27, "-1");
	}
     }
    else
      muiClearRadio(obj);
  }
  else{
     if (trb24->active){
       muiSetActive(obj, 1);
       muiSetTBString(t23, muiGetTBString(t24));
       muiSetTBString(t27, muiGetTBString(t28));
       muiSetActive(trb24, 0);
       muiClearTBString(t24);
       muiClearTBString(t28);
      }
     else{
	    muiClearTBString(t23);
	    muiClearTBString(t27);
	    muiSetActive(trb23, 0);
	  }
  }
}


void lod4CB(muiObject *obj, enum muiReturnValue r){

  if (obj->active){
    if (trb26->active && trb21->active && trb22->active && trb23->active){
      if (fName[selList]) muiSetTBString(t24, fName[selList]);
	if (strcmp("-1", muiGetTBString(t27))){
	  muiSetTBString(t28, "-1");
	}
	else{
          int num;
	  char str[25];
	  sscanf(muiGetTBString(t26),"%d",&num);
	  sprintf(str,"%d", (num+10));
	  muiSetTBString(t27, str);
	  muiSetTBString(t28, "-1");
	}
    }
    else
      muiClearRadio(obj);
  }
  else{
    muiClearTBString(t24);
    muiClearTBString(t28);
    muiSetActive(trb24, 0);
  }
}

void lod1TBCB(muiObject *obj, enum muiReturnValue r){
  char *fName = muiGetTBString(t21);

  if (r != MUI_TEXTBOX_RETURN)  return;
  
  selList = getSelIndexOf(fName);
  redisplayAll();
}

void lod2TBCB(muiObject *obj, enum muiReturnValue r){
}

void lod3TBCB(muiObject *obj, enum muiReturnValue r){
}

void lod4TBCB(muiObject *obj, enum muiReturnValue r){
}


void InterCB(muiObject *obj, enum muiReturnValue r){

    muiClearRadio(trb21);
    muiClearRadio(trb22);
    muiClearRadio(trb23);
    muiClearRadio(trb24);
    muiClearTBString(t21);
    muiClearTBString(t22);
    muiClearTBString(t23);
    muiClearTBString(t24);
    muiClearTBString(t25);
    muiClearTBString(t26);
    muiClearTBString(t27);
    muiClearTBString(t28);
    
    t.isVRMLLOD = 0;
    strcpy(t.path, dName);
    if (selList>-1){
      sprintf(t.fName[0],"%s", fName[selList]);
      sprintf(t.fName[1],"%s", fName[selList]);
      sprintf(t.fName[2],"%s", fName[selList]);
      sprintf(t.fName[3],"%s", fName[selList]);
    }
}


void VRMLCB(muiObject *obj, enum muiReturnValue r){
  if (obj->active){
    t.isVRMLLOD = 1;
    if (selList<0){
      muiSetActive(trb25, 1);
      muiSetActive(trb26, 0);
    }
    else{
      if (fName[selList]){
        muiSetTBString(t21, fName[selList]);
        muiSetTBString(t25, "-1");
        muiSetActive(trb21, 1);
      }
    }
  }
    
}



void makeLODUI(void){
    muiNewUIList(3);
    b21 = muiNewButton(10, 100, 10, 35);
    b22 = muiNewButton(120, 220, 10, 35);
    b23 = muiNewButton(240, 340, 10, 35);
    muiLoadButton(b21, "Cancel");
    muiLoadButton(b22, "O.K.");
    muiLoadButton(b23, "Apply");
    muiSetCallback(b21, CancelCB);
    muiSetCallback(b22, OKCB);
    muiSetCallback(b23, ApplyCB);

    trb21 = muiNewTinyRadioButton(30, 145);
    muiLoadButton(trb21, "1");
    trb22 = muiNewTinyRadioButton(30, 115);
    muiLoadButton(trb22, "2");
    trb23 = muiNewTinyRadioButton(30, 85);
    muiLoadButton(trb23, "3");
    trb24 = muiNewTinyRadioButton(30, 55);
    muiLoadButton(trb24, "4");
    muiSetCallback(trb21, lod1CB);
    muiSetCallback(trb22, lod2CB);
    muiSetCallback(trb23, lod3CB);
    muiSetCallback(trb24, lod4CB);
    
    trb25 = muiNewTinyRadioButton(10, 210);
    muiLoadButton(trb25, "interpolated");
    trb26 = muiNewTinyRadioButton(10, 185);
    muiLoadButton(trb26, "via VRML");
    muiLinkButtons(trb25, trb26);
    muiSetActive(trb25, 1);
    muiSetCallback(trb25, InterCB);
    muiSetCallback(trb26, VRMLCB);

    l21 = muiNewLabel(60, 172, "filename");
    l22 = muiNewLabel(240, 172, "radius");

    t24 = muiNewTextbox(60, 220, 50);
    t23 = muiNewTextbox(60, 220, 80);
    t22 = muiNewTextbox(60, 220, 110);
    t21 = muiNewTextbox(60, 220, 140);
    
    t28 = muiNewTextbox(240, 300, 50);
    t27 = muiNewTextbox(240, 300, 80);
    t26 = muiNewTextbox(240, 300, 110);
    t25 = muiNewTextbox(240, 300, 140);
    
    muiSetCallback(t21, lod1TBCB);
    muiSetCallback(t22, lod2TBCB);
    muiSetCallback(t23, lod3TBCB);
    muiSetCallback(t24, lod4TBCB);
    muiSetCallback(t25, lod1TBCB);
    muiSetCallback(t26, lod2TBCB);
    muiSetCallback(t27, lod3TBCB);
    muiSetCallback(t28, lod4TBCB);
/*    muiAddToUIList(3, t21);
    muiAddToUIList(3, t22);
    muiAddToUIList(3, t22);
    muiAddToUIList(3, t24);
 */
}

void updateLOD (void){
    char distance[100];
    
    if (LODWID < 0) return;
    glutSetWindow (LODWID);
     muiSetActive (trb25, 0);
    muiSetActive (trb26, 0);
    if (t.isVRMLLOD){
	muiSetActive (trb26, 1);
	muiSetTBString (t21, t.fName[0]);
	muiSetTBString (t22, t.fName[1]);
	muiSetTBString (t23, t.fName[2]);
	muiSetTBString (t24, t.fName[3]);
    } else {
	muiSetActive (trb25, 1);
	muiSetTBString (t21, "");
	muiSetTBString (t22, "");
	muiSetTBString (t23, "");
	muiSetTBString (t24, "");
    }
    sprintf(distance, "%i", t.radius[0]);
    if (strcmp(distance, "0")) muiSetTBString (t25, distance);
    else muiSetTBString (t25, "");
    sprintf(distance, "%i", t.radius[1]);
    if (strcmp(distance, "0")) muiSetTBString (t26, distance);
    else muiSetTBString (t26, "");
    sprintf(distance, "%i", t.radius[2]);
    if (strcmp(distance, "0")) muiSetTBString (t27, distance);
    else muiSetTBString (t27, "");
    sprintf(distance, "%i", t.radius[3]);
    if (strcmp(distance, "0")) muiSetTBString (t28, distance);
    else muiSetTBString (t28, "");
    muiSetActive (trb21, (strcmp (t.fName[0], "")) && t.isVRMLLOD ? 1 : 0);
    muiSetActive (trb22, (strcmp (t.fName[1], "")) && t.isVRMLLOD ? 1 : 0);
    muiSetActive (trb23, (strcmp (t.fName[2], "")) && t.isVRMLLOD ? 1 : 0);
    muiSetActive (trb24, (strcmp (t.fName[3], "")) && t.isVRMLLOD ? 1 : 0);
}
  
void makeLODWindow(void){
    if ( LODWID <0 ) {
	glutInitWindowPosition(100+W+15, 100+H/2);
	glutInitWindowSize( 350, 240);
	glutInitDisplayMode( GLUT_RGB | GLUT_DOUBLE | GLUT_DEPTH);
	LODWID = glutCreateWindow("Level Of Detail");
	makeLODUI();
	muiInit(3); 
    } else {
      glutSetWindow (LODWID);
      glutShowWindow ();
    }
    updateLOD();
}


/**********************************************************/
/***************** ****  READ DIR  ***** ******************/
/**********************************************************/
/**********************************************************/

void scanDir(void){
    int a=-1, i;
    struct dirent **namelist;
    int n = scandir(dName, &namelist, 0, alphasort);
    
/*    printf("%d files in %s\n",n, dName); */
    for (i=0;i<n;i++){
      if (!opendir(namelist[i]->d_name)) {
        char *c1 = namelist[i]->d_name - 1 + strlen(namelist[i]->d_name);
        char *c2 = filter - 1 + strlen(filter);
	if ( *c1==*c2 && *(c1-1)==*(c2-1) && *(c1-2)==*(c2-2) ){
          if (!fName[++a]) fName[a] = (char*)malloc(256*sizeof(char));
          strcpy(fName[a], namelist[i]->d_name);
	}
      }
    }
    maxList = a + 1;
}

void makeLists(void){
  register int i=1;

    for (; i<=maxList; i++){
      char longName[256];
      sprintf(longName,"%s/%s",dName, fName[i-1]);
      list[i].list = ConvertVoxelObject2Faces(longName, 0, 0);
      getTextureSize(longName,
        &list[i].size[0],
        &list[i].size[1],
        &list[i].size[2]
      );
    }
    if (maxList>-1) topList = 0;
    else topList = -1;
    selList = -1;
}

void deleteLists( void ){
  register int i;

    for (i=1; i<=maxList; i++)
      glDeleteLists(list[i].list, 1);
}



/**********************************************************/
/**************** ****  CallBacks  ***** ******************/
/**********************************************************/
/**********************************************************/
void SliderCB(muiObject *obj, enum muiReturnValue value){
    float sliderval;

    if ((value != MUI_SLIDER_RETURN) && (value != MUI_SLIDER_THUMB)) return;
    sliderval = muiGetVSVal(obj);
    if (maxList<=4)
      topList = 0;
    else
      topList = (GLuint)((maxList-3)*(1-sliderval));
    redisplayAll();
}


void UpdateCB(muiObject *obj, enum muiReturnValue r){
    printf("\nDir: %s\n", t.path);
    printf("1. %s radius: %d\n", t.fName[0], t.radius[0]);
    printf("2. %s radius: %d\n", t.fName[1], t.radius[1]);
    printf("3. %s radius: %d\n", t.fName[2], t.radius[2]);
    printf("4. %s radius: %d\n", t.fName[3], t.radius[3]);
    
    printf("Rota: [%f, %f, %f]\n", t.rot[0], t.rot[1], t.rot[2]);
    printf("Scal: [%f, %f, %f]\n", t.scale[0], t.scale[1], t.scale[2]);
    printf("Repe: [%d, %d, %d]\n", t.rep[0], t.rep[1], t.rep[2]);
    printf("BBox: [%f, %f, %f]\n", t.bBox[0], t.bBox[1], t.bBox[2]);

  updateObj();
}



void LODCB(muiObject *obj, enum muiReturnValue r){

    makeLODWindow();
}


void ScaleCB(muiObject *obj, enum muiReturnValue r){
    if (mode != SCALE){
      glutSetWindow(subAxisWID);
      glutSetCursor(GLUT_CURSOR_UP_DOWN);
      glutSetWindow(mainWID);
      mode = SCALE;
    }
}


void RotateCB(muiObject *obj, enum muiReturnValue r){
    if (mode != ROTATE){
      glutSetWindow(subAxisWID);
      glutSetCursor(GLUT_CURSOR_CYCLE);
      glutSetWindow(mainWID);
      mode = ROTATE;
    }
}


void RescanCB(muiObject *obj, enum muiReturnValue r){
    GLuint actWID = glutGetWindow();
    strcpy(dName, muiGetTBString(t4));
    scanDir();

    glutSetWindow(subRoll1WID);
    makeLists();

    glutSetWindow(subRoll2WID);
    makeLists();

    glutSetWindow(subRoll3WID);
    makeLists();

    glutSetWindow(subAxisWID);
    deleteLists();
    makeLists();

    glutSetWindow(actWID);
    selList = -1;
    redisplayAll();
}


void XCB(muiObject *obj, enum muiReturnValue r){
    switch (t.rep[0]){
	case  0:
	    muiSetTBString(t1, "-1");
	    t.rep[0] = -1;
	    break;
	default:
	    muiClearTBString(t1);
	    t.rep[0] = 0;
    }
}


void YCB(muiObject *obj, enum muiReturnValue r){
    switch (t.rep[1]){
	case  0:
	    muiSetTBString(t2, "-1");
	    t.rep[1] = -1;
	    break;
	default:
	    muiClearTBString(t2);
	    t.rep[1] = 0;
    }
}

void ZCB(muiObject *obj, enum muiReturnValue r){
    switch (t.rep[2]){
	case  0:
	    muiSetTBString(t3, "-1");
	    t.rep[2] = -1;
	    break;
	default:
	    muiClearTBString(t3);
	    t.rep[2] = 0;
    }
}


void dirTBCB(muiObject *obj, enum muiReturnValue r){
}


void xTBCB(muiObject *obj, enum muiReturnValue r){
}


void yTBCB(muiObject *obj, enum muiReturnValue r){
}


void zTBCB(muiObject *obj, enum muiReturnValue r){
}



/**********************************************************/
/****************** ****  MakeUI  ***** *******************/
/**********************************************************/
/**********************************************************/
void makeUI(void){

    muiNewUIList(2);	/* makes an MUI display list (number 1) */
    b1 = muiNewButton(110, 200, 70, 95);
    b2 = muiNewButton(215, 305, 70, 95);
    b3 = muiNewButton(320, 420, 10, 35);
    b4 = muiNewButton(320, 420, 430, 455);
    b5 = muiNewButton(320, 420, 70, 95);
    muiLoadButton(b1, "Rotate");
    muiLoadButton(b2, "Scale");
    muiLoadButton(b3, "Update");
    muiLoadButton(b4, "Rescan");
    muiLoadButton(b5, "LOD ...");
    muiSetCallback(b1, RotateCB);
    muiSetCallback(b2, ScaleCB);
    muiSetCallback(b3, UpdateCB);
    muiSetCallback(b4, RescanCB);
    muiSetCallback(b5, LODCB);
    
    trb1 = muiNewTinyRadioButton(10, 75);
    muiLoadButton(trb1, "X");
    trb2 = muiNewTinyRadioButton(10, 45);
    muiLoadButton(trb2, "Y");
    trb3 = muiNewTinyRadioButton(10, 15);
    muiLoadButton(trb3, "Z");
    muiSetCallback(trb1, XCB);
    muiSetCallback(trb2, YCB);
    muiSetCallback(trb3, ZCB);
    
    
    t1 = muiNewTextbox(50, 100, 70);
    t2 = muiNewTextbox(50, 100, 40);
    t3 = muiNewTextbox(50, 100, 10);
    t4 = muiNewTextbox(10, 310, 430);
    muiSetTBString(t4, dName);
    muiSetCallback(t1, xTBCB);
    muiSetCallback(t2, yTBCB);
    muiSetCallback(t3, zTBCB);
    muiSetCallback(t4, dirTBCB);
    
    l1 = muiNewLabel(10, 462, "Directory");
    l2 = muiNewLabel(10, 100, "Repeat");
    
    vs = muiNewVSlider(420, 120, 420, 0, 10);
    muiSetVSValue(vs, 1.0);
    muiSetVSArrowDelta(vs, 230/(maxList-3));
    muiSetCallback(vs, SliderCB);
}

/**********************************************************/
/******************* ****  IDLES  ***** *******************/
/**********************************************************/
/**********************************************************/
void idle1(void){

    if (selList == topList){
      if (abs((int)rot1[0])>30) rot1[0]-= 0.1;
      else rot1[0]+= 0.1;
      rot1[1] += 1.0;
      glutPostWindowRedisplay(subRoll1WID);
    }
    else{
    rot1[0] = 15.0;
    rot1[1] = 45.0;
    rot1[2] = 0.0;
    glutPostWindowRedisplay(subRoll1WID);
    rot2[0] = 15.0;
    rot2[1] = 45.0;
    rot2[2] = 0.0;
    glutPostWindowRedisplay(subRoll2WID);
    rot3[0] = 15.0;
    rot3[1] = 45.0;
    rot3[2] = 0.0;
    glutPostWindowRedisplay(subRoll3WID);
    glutIdleFunc(NULL);
    }
}

void idle2(void){

    if (selList == topList+1){
      if (abs((int)rot2[0])>30) rot2[0]-= 0.1;
      else rot2[0]+= 0.1;
      rot2[1] += 1.0;
      glutPostWindowRedisplay(subRoll2WID);
    }
    else{
    rot1[0] = 15.0;
    rot1[1] = 45.0;
    rot1[2] = 0.0;
    glutPostWindowRedisplay(subRoll1WID);
    rot2[0] = 15.0;
    rot2[1] = 45.0;
    rot2[2] = 0.0;
    glutPostWindowRedisplay(subRoll2WID);
    rot3[0] = 15.0;
    rot3[1] = 45.0;
    rot3[2] = 0.0;
    glutPostWindowRedisplay(subRoll3WID);
    glutIdleFunc(NULL);
    }
}

void idle3(void){

    if (selList == topList+2){
      if (abs((int)rot3[0])>30) rot3[0]-= 0.1;
      else rot3[0]+= 0.1;
      rot3[1] += 1.0;
      glutPostWindowRedisplay(subRoll3WID);
    }
    else{
    rot1[0] = 15.0;
    rot1[1] = 45.0;
    rot1[2] = 0.0;
    glutPostWindowRedisplay(subRoll1WID);
    rot2[0] = 15.0;
    rot2[1] = 45.0;
    rot2[2] = 0.0;
    glutPostWindowRedisplay(subRoll2WID);
    rot3[0] = 15.0;
    rot3[1] = 45.0;
    rot3[2] = 0.0;
    glutPostWindowRedisplay(subRoll3WID);
    glutIdleFunc(NULL);
    }
}

void clearRotations(void){
    rot1[0] = 15.0;
    rot1[1] = 45.0;
    rot1[2] = 0.0;
    
    rot2[0] = 15.0;
    rot2[1] = 45.0;
    rot2[2] = 0.0;
    
    rot3[0] = 15.0;
    rot3[1] = 45.0;
    rot3[2] = 0.0;
}

/**********************************************************/
/***************** ****  RESHAPE  ***** *******************/
/**********************************************************/
/**********************************************************/
void ReshapeAxis(GLint w, GLint h){
    
  glViewport	( 0,0,w,h ) ;
  glMatrixMode  ( GL_PROJECTION ) ;
  glLoadIdentity( ) ;
  gluPerspective( 60.0, (GLfloat) w/h, 1.0, 100.0 ) ;
  glMatrixMode  ( GL_MODELVIEW ) ;
}


void ReshapeRoll(GLint w, GLint h){
    
  glViewport	( 0,0,w,h ) ;
  glMatrixMode  ( GL_PROJECTION ) ;
  glLoadIdentity( ) ;
  gluPerspective( 40.0, (GLfloat) w/h, 1.0, 100.0 ) ;
  glMatrixMode  ( GL_MODELVIEW ) ;
}



/**********************************************************/
/***************** ****  DISPLAY  ***** *******************/
/**********************************************************/
/**********************************************************/
void redisplayAll(){
    
    glutPostWindowRedisplay(subRoll1WID);
    glutPostWindowRedisplay(subRoll2WID);
    glutPostWindowRedisplay(subRoll3WID);
    glutPostWindowRedisplay(subAxisWID);
    if (LODWID>0){
	glutPostWindowRedisplay(LODWID);
    }
}
void updateAll (){
  TTexture t2;

    memcpy(&t2, &t, sizeof(TTexture));


    if (strcmp(t.path, dName)){
      int index;
      GLuint actWID = glutGetWindow();
      
      strcpy(dName, t.path);
      muiSetTBString(t4, t.path);
      scanDir();

      glutSetWindow(subRoll1WID);
      makeLists();

      glutSetWindow(subRoll2WID);
      makeLists();

      glutSetWindow(subRoll3WID);
      makeLists();

      glutSetWindow(subAxisWID);
      deleteLists();
      makeLists();

      glutSetWindow(actWID);
      if ((index = getSelIndexOf(t.fName[0]))>=0){
        selList = index-1;
	memcpy(&t, &t2, sizeof(TTexture));
    if (LODWID>0){
	updateLOD();
    }
    redisplayAll();
  
      }
    }
    else{
      int index = getSelIndexOf(t.fName[0]);
      if (index>=0) {
        selList = index-1;
   if (LODWID>0){
	updateLOD();
    }
    redisplayAll();
        }
    }

}

void DisplayAxis (void ){
  int maxSize = MAX3(
    list[selList+1].size[0],
    list[selList+1].size[1],
    list[selList+1].size[2]
  );

    glClearColor (0.0, 0.0, 0.0, 1.0);
    glClear (GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);
    
  glMatrixMode (GL_MODELVIEW);
    glEnable (GL_LIGHTING);
    glPushMatrix();
    glTranslatef(0.0, 0.0, -20);
    glRotatef(rot[0], 1, 0, 0);
    glRotatef(rot[1], 0, 1, 0);
    glRotatef(rot[2], 0, 0, 1);
    
    if (selList>-1) {
      glPushMatrix();
	glScalef(
	  8.0/maxSize,
	  8.0/maxSize,
	  8.0/maxSize
	);
	AXES(
	  list[selList+1].size[0],
	  list[selList+1].size[1],
	  list[selList+1].size[2]
	)

        glScalef(t.scale[0], t.scale[1], t.scale[2]);
        glRotatef(t.rot[0], 1, 0, 0);
        glRotatef(t.rot[1], 0, 1, 0);
        glRotatef(t.rot[2], 0, 0, 1);
	AXES(
	  list[selList+1].size[0],
	  list[selList+1].size[1],
	  list[selList+1].size[2]
	)
	glTranslatef(
	  (float)list[selList+1].size[1]/-2.0,
	  (float)list[selList+1].size[2]/-2.0,
	  (float)list[selList+1].size[0]/-2.0
	);
        glCallList(list[selList+1].list);
      glPopMatrix();
    }
  
    glDisable (GL_LIGHTING);
    glPopMatrix();

  glutSwapBuffers();
}


void DisplayRoll1 (void ){
  int maxSize = MAX3(
    list[topList+1].size[0],
    list[topList+1].size[1],
    list[topList+1].size[2]
  );

    glClearColor (0.0, 0.0, 0.0, 1.0);
    glClear (GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);
    
  glMatrixMode (GL_MODELVIEW);
    glEnable (GL_LIGHTING);
    glPushMatrix();
    glTranslatef(0.0, 0.0, -20.0);
    if (topList>-1){
      glPushMatrix();
	glScalef(
	  8.0/maxSize,
	  8.0/maxSize,
	  8.0/maxSize
	);

      glRotatef(rot1[0], 1, 0, 0);
      glRotatef(rot1[1], 0, 1, 0);
      glRotatef(rot1[2], 0, 0, 1);
      
      if (selList == topList && selList>-1){
      BOX(
	  list[topList+1].size[0],
	  list[topList+1].size[1],
	  list[topList+1].size[2]
      );
      AXES(
	  list[topList+1].size[0],
	  list[topList+1].size[1],
	  list[topList+1].size[2]
      );
      }
	glTranslatef(
          (float)list[topList+1].size[1]/-2.0,
          (float)list[topList+1].size[2]/-2.0,
          (float)list[topList+1].size[0]/-2.0
        );

      glCallList(list[topList+1].list);
      glPopMatrix();
    }
    if (selList == topList && selList>-1){
      glDisable(GL_LIGHTING);
      glCallList(list[0].list);
      glEnable(GL_LIGHTING);
    }
  
  glPopMatrix();
  glutSwapBuffers();
}

void DisplayRoll2 (void ){
  int maxSize = MAX3(
    list[topList+2].size[0],
    list[topList+2].size[1],
    list[topList+2].size[2]
  );

    glClearColor (0.0, 0.0, 0.0, 1.0);
    glClear (GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);
    
  glMatrixMode (GL_MODELVIEW);
    glEnable (GL_LIGHTING);
    glPushMatrix();
    glTranslatef(0.0, 0.0, -20.0);
  
    if (topList>-1){
      glPushMatrix();
	glScalef(
	  8.0/maxSize,
	  8.0/maxSize,
	  8.0/maxSize
	);
      glRotatef(rot2[0], 1, 0, 0);
      glRotatef(rot2[1], 0, 1, 0);
      glRotatef(rot2[2], 0, 0, 1);
    if (selList == topList+1 && selList>-1){
      BOX(
	  list[topList+2].size[0],
	  list[topList+2].size[1],
	  list[topList+2].size[2]
      );
      AXES(
	  list[topList+2].size[0],
	  list[topList+2].size[1],
	  list[topList+2].size[2]
      );
      }
	glTranslatef(
	  (float)list[topList+2].size[1]/-2.0,
	  (float)list[topList+2].size[2]/-2.0,
	  (float)list[topList+2].size[0]/-2.0
	);

      glCallList(list[topList+2].list);
      glPopMatrix();
    }
    if (selList == topList+1 && selList>-1){
      glDisable(GL_LIGHTING);
      glCallList(list[0].list);
      glEnable(GL_LIGHTING);
    }
  
  glPopMatrix();
  glutSwapBuffers();
}

void DisplayRoll3 (void ){
  int maxSize = MAX3(
    list[topList+3].size[0],
    list[topList+3].size[1],
    list[topList+3].size[2]
  );
    glClearColor (0.0, 0.0, 0.0, 1.0);
    glClear (GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);
    
  glMatrixMode (GL_MODELVIEW);
    glEnable (GL_LIGHTING);
    glPushMatrix();
    glTranslatef(0.0, 0.0, -20);
  
    if (topList>-1){
      glPushMatrix();
	glScalef(
	  8.0/maxSize,
	  8.0/maxSize,
	  8.0/maxSize
	);
      glRotatef(rot3[0], 1, 0, 0);
      glRotatef(rot3[1], 0, 1, 0);
      glRotatef(rot3[2], 0, 0, 1);
      if (selList == topList+2 && selList>-1){
      BOX(
	  list[topList+3].size[0],
	  list[topList+3].size[1],
	  list[topList+3].size[2]
      );
      AXES(
	  list[topList+3].size[0],
	  list[topList+3].size[1],
	  list[topList+3].size[2]
      );
      }
	glTranslatef(
	  (float)list[topList+3].size[1]/-2.0,
	  (float)list[topList+3].size[2]/-2.0,
	  (float)list[topList+3].size[0]/-2.0
	);

      glCallList(list[topList+3].list);
      glPopMatrix();
    }
    if (selList == topList+2 && selList>-1){
      glDisable(GL_LIGHTING);
      glCallList(list[0].list);
      glEnable(GL_LIGHTING);
    }
  
  glPopMatrix();
  glutSwapBuffers();
}

/**********************************************************/
/****************** ****  MOUSE  ***** ********************/
/**********************************************************/
/**********************************************************/
void mouseDownRoll1CB(int button, int state, int x, int y){
    if (state == GLUT_DOWN && selList!=topList && topList>-1){
      selList = topList;
      if (!t.isVRMLLOD){
        strcpy(t.path, dName);
        sprintf(t.fName[0],"%s", fName[selList]);
        sprintf(t.fName[1],"%s", fName[selList]);
        sprintf(t.fName[2],"%s", fName[selList]);
        sprintf(t.fName[3],"%s", fName[selList]);
      }
      clearTextPropr();
      clearRotations();
      glutIdleFunc(idle1);
      redisplayAll();
    }
}

void mouseDownRoll2CB(int button, int state, int x, int y){
    if (state == GLUT_DOWN && selList!=topList+1 && topList>-1){
      selList = topList+1;
      if (!t.isVRMLLOD){
        strcpy(t.path, dName);
        sprintf(t.fName[0],"%s", fName[selList]);
        sprintf(t.fName[1],"%s", fName[selList]);
        sprintf(t.fName[2],"%s", fName[selList]);
        sprintf(t.fName[3],"%s", fName[selList]);
      }
      clearTextPropr();
      clearRotations();
      glutIdleFunc(idle2);
      redisplayAll();
    }
}

void mouseDownRoll3CB(int button, int state, int x, int y){
    if (state == GLUT_DOWN && selList!=topList+2 && topList>-1){
      selList = topList+2;
      if (!t.isVRMLLOD){
        strcpy(t.path, dName);
        sprintf(t.fName[0],"%s", fName[selList]);
        sprintf(t.fName[1],"%s", fName[selList]);
        sprintf(t.fName[2],"%s", fName[selList]);
        sprintf(t.fName[3],"%s", fName[selList]);
      }
      clearTextPropr();
      clearRotations();
      glutIdleFunc(idle3);
      redisplayAll();
    }
}

void mouseDownAxisCB(int button, int state, int x, int y){
    lastState = state;
    if (state == GLUT_DOWN && selList>-1){
      lastX = x;
      lastY = y;
      lastBut = button;
      switch(mode){
        case ROTATE:
            break;
        case SCALE:
            break;
      }
    }
}


void mouseMoveAxisCB(int x, int y){
    if (lastState == GLUT_DOWN && selList>-1 && (x!=lastX || y!=lastY)){
      switch(mode){
        case ROTATE:
		switch(lastBut){
		  case GLUT_LEFT_BUTTON:
			t.rot[0] += lastY-y;
			break;
		  case GLUT_MIDDLE_BUTTON:
			t.rot[1] += lastY-y;
			break;
		  case GLUT_RIGHT_BUTTON:
			t.rot[2] += lastY-y;
			break;
		}
            break;
        case SCALE:
		switch(lastBut){
		  case GLUT_LEFT_BUTTON:
			if (lastY>y)
			  t.scale[0] *= 1.2;
			else
			  t.scale[0] *= 0.8;
			break;
		  case GLUT_MIDDLE_BUTTON:
			if (lastY>y)
			  t.scale[1] *= 1.2;
			else
			  t.scale[1] *= 0.8;
			break;
		  case GLUT_RIGHT_BUTTON:
			if (lastY>y)
			  t.scale[2] *= 1.2;
			else
			  t.scale[2] *= 0.8;
			break;
		}
            break;
      }
      lastX = x;
      lastY = y;
      glutPostRedisplay();
    }
}
/**********************************************************/
/***************** ****  LIGHTS  ***** ********************/
/**********************************************************/
/**********************************************************/
void initLight(void){
    GLfloat light_ambient[] = { 0.5, 0.5, 0.5, 1.0 };
    GLfloat light_diffuse[] = { 0.9, 0.9, 0.9, 1.0 };
    GLfloat light_specular[] = { 0.9, 0.9, 0.9, 1.0 };
    GLfloat light_position[] = { 14.0, 14.0, 14.0, 0.0 };
    GLfloat light_position1[] = { -14.0, -14.0, 14.0, 0.0 };
    GLfloat light_position2[] = { -14.0, 14.0, -14.0, 0.0 };
    GLfloat lmodel_ambient[] = { 0.4, 0.4, 0.4, 1.0 };
    
    glLightfv(GL_LIGHT0, GL_AMBIENT, light_ambient);
    glLightfv(GL_LIGHT0, GL_DIFFUSE, light_diffuse);
    glLightfv(GL_LIGHT0, GL_SPECULAR, light_specular);
    glLightfv(GL_LIGHT0, GL_POSITION, light_position);
    
    glLightfv(GL_LIGHT1, GL_AMBIENT, light_ambient);
    glLightfv(GL_LIGHT1, GL_DIFFUSE, light_diffuse);
    glLightfv(GL_LIGHT1, GL_SPECULAR, light_specular);
    glLightfv(GL_LIGHT1, GL_POSITION, light_position1);
    
    glLightfv(GL_LIGHT2, GL_AMBIENT, light_ambient);
    glLightfv(GL_LIGHT2, GL_DIFFUSE, light_diffuse);
    glLightfv(GL_LIGHT2, GL_SPECULAR, light_specular);
    glLightfv(GL_LIGHT2, GL_POSITION, light_position2);
    
    glLightModelfv(GL_LIGHT_MODEL_AMBIENT, lmodel_ambient);
   
    glEnable(GL_LIGHT0);
    glEnable(GL_LIGHT1);
    glEnable(GL_LIGHT2); 

    glEnable (GL_DEPTH_TEST);
    glDepthFunc (GL_LEQUAL);
    glEnable (GL_NORMALIZE);
    glShadeModel (GL_SMOOTH);
    glDisable (GL_BLEND);
}


/**********************************************************/
/******************* ****  INIT  ***** ********************/
/**********************************************************/
/**********************************************************/
void clearTextPropr( void ){
    int i;
    t.rep[0] = 0;
    t.rep[1] = 0;
    t.rep[2] = 0;
    t.scale[0] = 1.0;
    t.scale[1] = 1.0;
    t.scale[2] = 1.0;
    t.rot[0] = 0.0;
    t.rot[1] = 0.0;
    t.rot[2] = 0.0;
    
    t.isVRMLLOD = 0;
    
    rot[0] = 0.0;
    rot[1] = 0.0;
    rot[2] = 0.0;
}

void createQuadList(void){
    list[0].list = glGenLists(1);
    glNewList(list[0].list, GL_COMPILE);
      glLineWidth(4.0);
      glColor3f(1.0, 0.0, 0.0);
      glBegin(GL_LINE_LOOP);
        glVertex3f(-7.0, -7.0, 0.0);
        glVertex3f( 7.0, -7.0, 0.0);
        glVertex3f( 7.0,  7.0, 0.0);
        glVertex3f(-7.0,  7.0, 0.0);
      glEnd();
      glLineWidth(1.0);
    glEndList();
}

void init(void){
    int i;
    FILE *tmp;

    t.isVRMLLOD = 0;
    for (i=0; i<4; i++){
	t.radius[i] = 0;
	strcpy (t.fName[i], "");
    }
   
    clearTextPropr();
    clearRotations();
    
    dName = (char*)malloc(256);
    
    system("pwd>tmp");
    tmp=fopen("tmp","r");
    fscanf(tmp,"%s",dName);
    fclose(tmp);
    system("rm -f tmp");

    strcat(dName, "/textures/");
    scanDir(); 
    makeUI();
    muiInit(2);
}

/**********************************************************/
/******************* ****  MAIN  ***** ********************/
/**********************************************************/
/**********************************************************/
void createTPWindow(){

    glutInitWindowPosition(650, 100);
    glutInitWindowSize( W, H);
    glutInitDisplayMode( GLUT_RGB | GLUT_DOUBLE | GLUT_DEPTH );
    mainWID = glutCreateWindow("Texture properties");
    
    init();
    
    subRoll1WID = glutCreateSubWindow(mainWID, 320, H-300-120, 100, 100);
      createQuadList();
      makeLists();
      initLight();
      glutDisplayFunc(DisplayRoll1);
      glutReshapeFunc(ReshapeRoll);
      glutMouseFunc(mouseDownRoll1CB);
    
    subRoll2WID = glutCreateSubWindow(mainWID, 320, H-200-120, 100, 100);
      createQuadList();
      makeLists();
      initLight();
      glutDisplayFunc(DisplayRoll2);
      glutReshapeFunc(ReshapeRoll);
      glutMouseFunc(mouseDownRoll2CB);
    
    subRoll3WID = glutCreateSubWindow(mainWID, 320, H-100-120, 100, 100);
      createQuadList();
      makeLists();
      initLight();
      glutDisplayFunc(DisplayRoll3);
      glutReshapeFunc(ReshapeRoll);
      glutMouseFunc(mouseDownRoll3CB);
    
    subAxisWID = glutCreateSubWindow(mainWID, 10, H-300-120, 300, 300);
      createQuadList();
      makeLists();
      initLight();
      glutDisplayFunc(DisplayAxis);
      glutReshapeFunc(ReshapeRoll);
      glutMouseFunc(mouseDownAxisCB);
      glutMotionFunc(mouseMoveAxisCB);
    
}


void getTextureProp(void){

    strcpy(t.path, dName);
    if (LODWID>0){
    }
}

int getSelIndexOf(char *fn){
  register int i=0;
  
  printf("Searching for: %s\n", fn);
  for (;i<maxList;i++)
    if (strcmp(fn, fName[i])==0) return i+1;

}
