/***************************************************************************/
/*                                                                         */
/*                b3dt - 3D texture file builder v0.23                     */
/*                  (c)1998 Marek Uher, uher@uhkt.cz                       */
/*                                                                         */
/*   contrib.h - header file for contrib.c (contain auxiliary functions)   */
/*                                                                         */
/***************************************************************************/

#ifndef _CONTRIB_H_
#define _CONTRIB_H_ 1

/* if we want do debug */
#define DEBUG
/* then comment next line */
#undef DEBUG

/* standard work environment is unix */
#define UNIX 1
/* uncomment next line, if you are not working in unix */
/* #undef UNIX */

/* some miscellaneous constants */

/* i/o status */
#define OK 0
#define ERROR -1

/* constants for parsing help args */
#define HELP_INDEX 1
#define ARG_HELP HELP_INDEX

/* symbolic constants for command line args */
#define TEXTURE_TYPE 1
#define OBJECT_TYPE 2
#define OUTPUT_FILE 3

/* symbolic constants for texture types */
#define VTF_TEXTURE 0
#define STF_TEXTURE 1
#define CTF_TEXTURE 2

/* symbolic constants for messages */
#define B3DT_USAGE 0
#define B3DT_HELP 1
#define B3DT_START 2
#define B3DT_FILE_ERR 3
#define B3DT_END 10

/* string constants for messages */
#define MSG_USAGE "\nusage b3dt [texture type] [object type] [output file]"
#define MSG_START "3D texture builder v0.23, (c)1998 Marek Uher, uher@uhkt.cz"
#define MSG_END "\nexiting builder...\n"
#define MSG_FILE_ERR "\ncannot open output file\n"
#define MSG_ERR "\ncritical error: unknow error!?!"

/* function for putting message on terminal */
void PutMessage(int controlPoint);

/* function for setting up unix environment */
void InitEnvironment(void);

/* function for putting help infos on terminal */
void GetHelp(void);

/* function for parsing command line arguments */
void ParseArg(int index, char *arg);

#endif
/* End of file: contrib.h */
