/***************************************************************************/
/*                                                                         */
/*                b3dt - 3D texture file builder v0.23                     */
/*                  (c)1998 Marek Uher, uher@uhkt.cz                       */
/*                                                                         */
/*            b3dt.c - module to b3dt (contain main function)              */
/*                                                                         */
/***************************************************************************/

/* include header files */

/* standard system header files */ 
#include <stdio.h>
#include <stdlib.h>

/* user defined header files */
#include "contrib.h"
#include "txengine.h"

/* main function for 3D texture builder */
int main(int argc, char *argv[]){

	/* declare loop counter */
	int counter = 0;

	/* get program info */
	PutMessage(B3DT_START);

	/* test command line args for help option */
	if (argc == 2) ParseArg(HELP_INDEX, argv[ARG_HELP]);

	/* wrong numbers of arguments, say usage and exit */
	if ((argc != 4)) PutMessage(B3DT_USAGE);

	/* init program environment */
	InitEnvironment();

	/* parse command line arguments */
	for (counter = 1; counter < argc; counter++)
		ParseArg(counter, argv[counter]);

	/* build 3d texture file */
	Build3DTexture();

	/* say, that we are going away */
	PutMessage(B3DT_END);

	/* return to shell */
	return(0);
}

/* End of file: b3dt.c */
