/***************************************************************************/
/*                                                                         */
/*                m3dt - 3D texture file mapper v0.23                      */
/*                  (c)1998 Marek Uher, uher@uhkt.cz                       */
/*                                                                         */
/*    parser.h - header file for parser.c (contain auxiliary functions)    */
/*                                                                         */
/***************************************************************************/

#ifndef _PARSER_H_
#define _PARSER_H_ 1

/* if we want do debug */
#define DEBUG
/* then comment next line */
#undef DEBUG

/* standard work environment is unix */
#define UNIX 1
/* uncomment next line, if you are not working in unix */
/* #undef UNIX */

/* some miscellaneous constants */

/* i/o status */
#define OK 0
#define ERROR -1

/* constants for parsing help args */
#define HELP_INDEX 1
#define ARG_HELP HELP_INDEX

/* symbolic constants for command line args */
#define LANDSCAPE_FILE 1
#define CONTAINER_FILE 2

/* symbolic constants for messages */
#define M3DT_USAGE 0
#define M3DT_HELP 1
#define M3DT_START 2
#define M3DT_FILE_ERR 3
#define M3DT_LFILE_ERR 4
#define M3DT_CFILE_ERR 5
#define M3DT_TFILE_ERR 6
#define M3DT_END 10

/* string constants for messages */
#define MSG_USAGE "\nusage m3dt [landscape file] [texture container file]"
#define MSG_START "3D texture mapper v0.23, (c)1998 Marek Uher, uher@uhkt.cz"
#define MSG_END "\nexiting mapper...\n"
#define MSG_FILE_ERR "\ncannot open input file\n"
#define MSG_LFILE_ERR "\ncannot open input landscape file\n"
#define MSG_CFILE_ERR "\ncannot open input scene description file\n"
#define MSG_TFILE_ERR "\ncannot open input texture file\n" 
#define MSG_ERR "\ncritical error: unknow error!?!"

/* function for putting message on terminal */
void PutMessage(int controlPoint);

/* function for setting up unix environment */
void InitEnvironment(void);

/* function for putting help infos on terminal */
void GetHelp(void);

/* function for parsing command line arguments */
void ParseArg(int index, char *arg);

#endif

/* End of file: contrib.h */
