/***************************************************************************/
/*                                                                         */
/*                m3dt - 3D texture file mapper v0.23                      */
/*                  (c)1998 Marek Uher, uher@uhkt.cz                       */
/*                                                                         */
/*            m3dt.c - module to m3dt (contain main function)              */
/*                                                                         */
/***************************************************************************/

/* include header files */

/* standard system header files */ 
#include <stdio.h>
#include <stdlib.h>

/* user defined header files */
#include "parser.h"
#include "mpengine.h"

/* main function for 3D texture maper */
int main(int argc, char *argv[]){

	/* declare loop counter */
	int counter = 0;

	/* get program info */
	PutMessage(M3DT_START);

	/* test command line args for help option */
	if (argc == 2) ParseArg(HELP_INDEX, argv[ARG_HELP]);

	/* wrong numbers of arguments, say usage and exit */
	if ((argc != 3)) PutMessage(M3DT_USAGE);

	/* init program environment */
	InitEnvironment();

	/* parse command line arguments */
	for (counter = 1; counter < argc; counter++)
		ParseArg(counter, argv[counter]);

	/* map 3d texture file */
	Map3DTexture();

	/* say, that we are going away */
	PutMessage(M3DT_END);

	/* return to shell */
	return(0);
}

/* End of file: m3dt.c */
